screen poset_points(ppt, kpt):
    $ sppt = "".join(sorted(list(ppt)))
    $ skpt = "".join(sorted(list(kpt)))
    vbox:
        xalign 0.5
        yalign 0.5
        add "poset_kool_[skpt].png"
    vbox:
        xalign 0.5
        yalign 0.5
        add "poset_me_[sppt].png"

label posetgame:
    "Choose a point on the poset."
    show coolwitch at left
    with move
    call screen poset_select
    $ playerposet_pt = _return
    $ koolposet_pt = set(renpy.random.choice([["a"],["b"],["c"],["a","b"],["a","c"],["b","c"],["a","b","c"]]))
    show screen poset_points(playerposet_pt, koolposet_pt)
    kw "This is the point I chose in blue."
    if playerposet_pt == koolposet_pt:
        kw "We both picked the same point! What a coincidence? In the case of a tie, the defender successfully blocks in battle"
    elif playerposet_pt.issubset(koolposet_pt):
        kw "As you can see, my point is above yours. That means in battle, my defense would block your attack. Or my attack would break through your defense."
    elif playerposet_pt.issuperset(koolposet_pt):
        kw "As you can see, your point is above mine. That means in battle, your defense would block my attack. Or your attack would break through my defense."
    else:
        kw "As you can see, our points are {b}incomparable{/b}. Neither one is bigger or smaller than the other. In battle, the attacker would succeed."
    hide screen poset_points
    show coolwitch at center
    with move
    return

label witch2:

    # BEGIN DCHANGE
    $ witchid = "witch2"
    jump witch

    define kw = Character("[nameknown]", color="FF0000")
    # END DCHANGE

    label .shun:
        show coolwitch
        $ traitor = witches[talked_to]["name"]
        "Beat it. I saw you being all buddy buddy with [traitor], earlier. I'd never hang out with a lame-o. So, get lost."
        return

    label .intro:
        play music "audio/severetiredamage.mp3" fadeout 1

        show coolwitch

        menu:

            "Hi!":
                $ coolalienquestion = False

            "Woah! Are you an alien?":
                $ coolalienquestion = True

        kw "Do you really think you're cool enough to talk to me?"

        kw "You're stone-faced. I like it. You've got confidence."

        kw "You're much cooler than these lame-o's (Lizard and Machine Enemy-Overachivers)."

        kw "Let me let you in on a cool kid secret..."

        hide coolwitch

        show coolwitchzoom

        show coolwitchzoom:
            zoom 1.75

        kw "{b}Posets{/b}"

        hide coolwitchzoom

        show coolwitch

        kw "So, you think you're cool enough to learn about {b}posets{/}?"

        a "{b}Posets{/b}? What are those?"

        kw "Only the coolest thing in this galaxy! Haven't you ever heard of mind control? AKA wizard-powning spells. You can stop your enemy from ever casting their spell. {b}POSETS{/b} ARE THE BEST."

        menu:

            "Yes. Teach me.":
                a "I don't know what these {b}posets{/b} are... So, obviously you should teach me."

            "No. Fight me.":
                a "Nope. Time magic is the best. Fight me."
                kw "I don't have to. You already failed to protect against a high level mind control {b}poset{/b}. You won't even throw a punch."
                a "You don't know that!"
                kw "Try and fight me!"
                kw "You can't, can you?"
                kw "Do you want to know why?"

                hide coolwitch

                show coolwitchzoom

                show coolwitchzoom:
                    zoom 1.75

                kw "{b}Posets{/b} are the best."

                hide coolwitchzoom

                show coolwitch

                a "There is no way mind control magic is legal in the wizard tournament."
                kw "Neither is time control magic."
                a "So, we're even!"
                kw "Even? You can't use any time control magic during the tournament. There are plenty of tournament compliant {b}posets{/b}."
                a "Yeah? Like what?"

        kw "The only {b}poset{/b} I can teach you about before the tournament, is this one."

        show coolwitch at left
        with move

        show poset red:
            yanchor 0.5
            yalign 0.5
            xalign 0.75
            zoom 2.0


        kw "Have you ever seen a cooler looking thing in your life?"

        kw "A {b}poset{/b} is a {b}set{/b} with a {b}partial ordering{/b}."

        kw "The {b}set{/b} is the group of circles."

        hide poset red

        show poset red arrows:
            yanchor 0.5
            yalign 0.5
            xalign 0.75
            zoom 2.0

        kw "And the {b}partial ordering{/b} is the flow. The bottom ones flow into the top ones."

        a "What?"

        $ books[bookid]["mentioned"] = True # DCHANGE
        $ persistent.books = books # DCHANGE
        kw "Look! You just need to go read \"[booktitle]\", okay! It's in the library! There are pictures of posets! It's great!"

        menu:

            "You're right. They're cool":
                kw "Thank you! Finally! Someone who gets it!"

            "It doesn't seem so great to me":
                kw "What are you talking about? {b}Posets {/b}are the coolest thing since absolute zero."
                #use original poset pic
                hide poset red arrows
                show poset red:
                    yanchor 0.5
                    yalign 0.5
                    xalign 0.75
                    zoom 2.0

                kw "Look at how cool this thing is!"
                kw "Look at it!"
                kw "This thing looks so cool!"
                kw "And it's definition is complex, so you know it's good stuff!"
                kw "How can you not love it?"

        kw "They literally let you cancel your opponent's magical attacks!"
        kw "If you master these things, then you'll never get hit!"
        kw "And that's just defensive {b}posets{/b}!"
        kw "If you're a true master like me, then you can also use them to make sure that your next attack will always hit!"
        kw "You're a wizard who no one else can ever touch and your attacks will always hit!"
        kw "Also, {b}posets{/b} just look so freaking cool!"
        kw "They're the best thing ever!"

        a "Are you going to fangirl forever or are you going to teach me?"
        kw "I'll teach you... but first you have to prove that you're ready to learn the awe inspiring might of {b}posets{/b}."
        kw "Go read \"[booktitle]\" and then I'll teach you everything about posets you'll need to know for the tournament."
        a "Gotcha. Be back soon."
        kw "Yes! And then we'll practice {b}posets{/b}! Woo! So pumped!"

        return

    label .not_read:
        show coolwitch
        kw "I've read your mind. You haven't read about the coolest magic in the galaxy, yet."
        kw "So, what are you doing back here?"
        kw "Wait! I don't wanna know. Just go read the book and come back."
        kw "I don't want to waste anymore energy on a wizard who doesn't care about {b}posets{/b}."
        return

    label .after_read:
        show coolwitch
        kw "Alright! It's {b}poset{/b} time!"
        kw "Oh, by the way, my name is Ms. Teri Zorn."
        $ witches[witchid]["nameknown"] = name # DCHANGE
        $ nameknown = witches[witchid]["nameknown"] # DCHANGE
        kw "You just gained enough coolness points in my book to be on a first name basis with me."
        kw "Very few creatures have done that. So, good job."
        a "Thanks. I'm [pname]."
        kw "I'm glad to share the coolness of {b}posets{/b} with you, [pname]."
        a "Thank you for sharing. So... You said something about mind control earlier?"
        kw "Maybe. I don't think we have enough time for that right now. Maybe another time."
        kw "How about I show you how to cast two basic spells using {b}posets{/b}?"
        kw "You can use these to defend yourself by stopping your opponent's spell from hitting you, and by ensuring your next spell will hit its target."

        return

    label .to_practice:
        show coolwitch
        menu:
            kw "You ready to practice {b}poset{/} defenses?"

            "Yes!":
                return True

            "No":
                kw "Okay, let me know if you change your mind."
                return False

    label .practice:
        play music "audio/takethelead.mp3" fadeout 1

        show coolwitch
        $ play_posetgame = True
        while play_posetgame:
            call posetgame from _call_posetgame
            menu:
                kw "Would you like to play another round?"
                "Yes":
                    pass
                "No":
                    menu:
                        kw "Are you sure you want to leave practice?"

                        "Yes":
                            kw "Wow, so uncool. Jk, you are kool. I had a lot of fun sharing {b}posets{/b} with you. Aren't they the coolest structures, ever?"
                            kw "Good luck at the tournament! I'll see you in battle!"
                            $ play_posetgame = False

                        "Not yet.":
                            kw "Okay, then let's play another round."
        # "thanks for practicing, I'munna leave now bye."
        return

label book2:
    # menu:
    #     "Flip page?"
    #         "Yes."
    show bkg posetbook1
    $ renpy.pause()
    show bkg posetbook2
    $ renpy.pause()
    show bkg posetbook3
    $ renpy.pause()
    return
