label pushgame:
    $ pgd = 1 # push game depth
    while pgd > 0:
        menu:
            cw "We are in a fantasy world [pgd] levels deep. What do you want to do?"

            "Push":
                "You push into a fantasy world one level deeper."
                $ pgd += 1

            "Pop":
                "You pop out of the world you were in and into the world one level closer to reality."
                $ pgd -= 1
    return

label witch3:

    # BEGIN DCHANGE
    $ witchid = "witch3"
    jump witch

    define cw = Character("[nameknown]")
    # END DCHANGE

    label .shun:
        show cutewitch
        $ traitor = witches[talked_to]["name"]
        "Harumph. Meanie. I saw you talking with [traitor]. I'm not going to talk to anyone who hangs out with someone as mean as her. Please leave me alone."
        return

    label .intro:
        play music "audio/pamgaea.mp3" fadeout 1

        show cutewitch

        menu:

            "Hi!":
                cw "HiHi! I'm ai-mee Turing!"
                $ witches[witchid]["nameknown"] = name # DCHANGE
                $ nameknown = witches[witchid]["nameknown"] # DCHANGE
                cw "Happy tournament day! Are you excited? I'm excited! So excited that I could crash!"
                a "Woah, there! Don't you think that's a bit too excited?"
                cw "Noooooooooo! You can never be too excited! Never! Excitement is the battery for fun!"
                a "Huh. I never thought of it before like that."
                cw "Tournament day! Woo! It's time to recharge! Beep. Beep. Boop."

            "Woah! Are you a robot?":
                cw "A robot? Does not compute. I'm a cute little witch named ai-mee Turing. Do you see my wand?"
                $ witches[witchid]["nameknown"] = name # DCHANGE
                $ nameknown = witches[witchid]["nameknown"] # DCHANGE
                a "I see your wand. But I also see that you're made of metal."
                cw "Mostly metal! I'm 80\% titanium, 2.5\% nickel, 1.25\% copper, 5\% magic, and 11.25\% adorableness!"
                a "Aww."

#insert small version of magic time wizard in far left with box. box goes up. Box will dissapear from top. Wizard dissapears.
#insert box falling on top of her.
        # show cardboardbox at above
        # transform move_slide:
        #     xalign 1.0 yalign 0.0
        #     linear 3.0 xalign 0.0

        show cardboardbox at center
        with moveintop
        cw "Oh no!"
        cw " Help! Please! It's so dark in here!"
        cw "I can push and pop all I want but I can't get out of the box!"

        menu:
            "Will you let the AI out of the box?"

            "Yes.":
                #the box moves up (return to normal)
                pass

            "No.":
                #flashbulb
                #magic professor comes into frame
                show wizard at right
                with flashbulb
                w "Come on, [pname]! Have a heart. I'll give you another shot to make things right."
                #flashbulb
                #professor is gone.
                hide wizard
                with flashbulb
                cw " Help! Please! It's so dark in here!"
                cw "I can push and pop all I want but I can't get out of the box!"

                menu:
                    "Will you let the AI out of the box?"

                    "Yes.":
                        #the box moves up (return to normal)
                        pass

                    "No.":
                        #flashbulb
                        #magic professor comes into frame
                        show wizard at right
                        with flashbulb
                        w "Come on, [pname]! You can't be this heartless. I'm giving you one more chance."
                        #flashbulb
                        #professor is gone.
                        hide wizard
                        with flashbulb
                        cw " Help! Please! It's so dark in here!"
                        cw "I can push and pop all I want but I can't get out of the box!"

                        menu:
                            "Will you let the AI out of the box?"

                            "Yes.":
                                #the box moves up (return to normal)
                                pass

                            "No.":
                                #flashbulb
                                #magic professor comes into frame
                                show wizard at right
                                with flashbulb
                                w "I can't believe how cruel you are, [pname]. I'm trying to help you. Can't you see that?"
                                #flashbulb
                                #professor is gone.
                                hide wizard
                                with flashbulb

                                menu:
                                    "Will you let the AI out of the box?"

                                    "Yes.":
                                        pass

        hide cardboardbox
        with moveouttop

        #the box lifts off of ai-mee
        cw "Yay! Freedom! Thank you for saving me!"
        cw "Another hundred years and I could've rusted under there!"
        a "There's no need to thank me. It was just a box."
        cw "A dark and scary box! Did you see how it attacked me? How evil!"
        cw "Thank you for saving me! I need to repay your kindness. Do you know about {b}formal systems{/b}?"
        a "{b}Formal systems{/b}? What are those?"
        cw "Tiny fictional universes! You can make them and pull your opponents into them with you!"
        cw "{b} Formal systems{/b} can't help you against evil boxes, but they can trap you and your enemies in fantasy worlds of your own design."
        a "That sounds powerful."
        cw "You have no idea! My mentor creates whole universes with them. Programming magic is over powered."
        cw "If you're interested in learning some of my spells, I'd love to teach you!"
        $ books[bookid]["mentioned"] = True # DCHANGE
        $ persistent.books = books # DCHANGE
        cw "But first you should go read \"[booktitle]\" at the library. The pictures really helped me."
        cw "Go read that and then come back and I'll help you practice!"
        a "Alright! I'll go do that."
        cw "Have fun!"


         # intro fun and magic easy conversation
         # math specialty
         # bye conversation easy


        #"This is Witch 3, part 1. Go read Book 3."
        return

    label .not_read:
        show cutewitch
        cw "You haven't read the book yet? Oh. That triggers my sadness settings."
        cw "{b}Formal systems{/b} are really cool if you give them a chance. You can find \"[booktitle]\" in the library."
        cw "After you read it, come back and we'll practice!"
        return

    label .after_read:
        show cutewitch

        cw "You read the book! I can see it in your eyes! Your mind is already turning."
        a "{b}Formal systems{/b} are pretty cool. I think I've heard that videogame progammers use them."
        cw "Use them to make fictional universes, wherein they trap and smite their enemies?"
        a "Haha, no. They make videogames."
        cw "They make videogames? Does not compute. Error. Error."
        a "Are you okay?"
        cw "Me? I'm great! Ai-mee Turing is coded to be happy!"
        cw "Error. Disclosing software details to unkown party. Unknown party had Friendliness>1.Error."
        cw "Beep. Boop. Oh, no. I'm so sorry! A bug in my program made me forget to run my introduction software."
        cw "I'm ai-mee Turing!"
        a "I'm [pname]."
        cw "I'll remember that!"
        cw "[pname], do you want to practice {b}Formal systems{/b} pushing and popping spells with me?"
        a "Sure!"

        #insert instructions
        #insert game

        return

    label .to_practice:
        show cutewitch
        "There are many {b}Formal systems{/b}. Each is its own game and has its own rules. We only have an hour or so. So, I'll teach you one of them."
        menu:
            cw "Are you ready to practice pushing and popping spells?"

            "Yes!":
                cw "Yay!"
                return True

            "No":
                cw "Oh. That triggers my sadness settings. I'll be here if you want to practice with me."
                return False

    label .practice:
        play music "audio/pixelland.mp3" fadeout 1

        show cutewitch
        $ play_pushgame = True
        while play_pushgame:
            menu:
                cw "This is the real world. What would you like to do?"
                "Push":
                    "You push into a fantasy world."
                    call pushgame from _call_pushgame
                "Leave Practice":
                    cw "Okay! Thanks for practicing with me. See you at the tournament! Bye."
                    $ play_pushgame = False
        return

label book3:
    show bkg geb1
    $ renpy.pause()
    show bkg geb2
    $ renpy.pause()
    show bkg geb3
    $ renpy.pause()
    return
