define g = Character("Gumdrop", color="#800080")

label library:

    play music "audio/deliberatethought.mp3" fadeout 1

    scene bkg library
    with Dissolve(.5)

    pause .5

    show librarian
    with Dissolve(.5)

    "The library is an old building that smells like books."

    menu:
        "What do you do?"

        "Talk to librarian":
            jump .librarian

        "Go back to the hall":
            jump hallway

    label .librarian:
        ## BEGIN DCHANGE
        python:
            book_list = []
            for abookid in books:
                book = books[abookid]
                if (book["mentioned"] or book["read"]):
                    book_list.append('"'+book["title"]+'"')
            if len(book_list) > 2:
                books_string = ", ".join(book_list[:-1]) + ", or " + book_list[-1]
            elif len(book_list) == 2:
                books_string = " and ".join(book_list)
            elif len(book_list) == 1:
                books_string = "".join(book_list)
            else:
                books_string = ""
        ## END DCHANGE

        $ qline = "What book do you want to read?"

        if books_string != "":
            $ qline += " I read from your mind that you're seeking [books_string]."

        menu:

            g "Hello, [pname]. It is I, Gumdrop, the psychic librarian. I've been expecting you. Have you come to read a book?"

            "Yes.":
                $ booktitle = renpy.input(qline)
                $ booktitle = booktitle.strip()
                python:
                    bookid = None
                    for book in books:
                        if books[book]["title"].upper() == booktitle.upper():
                            bookid = book
                            break
                if bookid != None:
                    jump book
                else:
                    "'[booktitle]', you say? Sorry, I don't think we have that book."
                    jump library.librarian

            "No.":
                g "Oh, ok. Alright. I get it. [pname] the apprentice is too good for books."
                g "Alright. I'll know when you come around."
                g "I've already foreseen it."
                g "I'll be waiting."
                jump library
