#  BEGIN DCHANGE
label tourney:
    play music "audio/presenterator.mp3" fadeout 1
    scene bkg tournament
    "Welcome to the annual wizard tournament!"
    "Can you defeat all of your opponents in one on one magic duels?"

    $ beat = 0

    $ wn = witches["witch1"]["name"]
    show nerdywitch
    "First up, you battle [wn]"
    call fight("witch1") from _call_fight
    hide nerdywitch
    if _return:
        $ beat += 1

    "Let's get you all healed up for your second match."
    $ wn = witches["witch2"]["name"]
    show coolwitch
    "Up next, [wn]"
    call fight("witch2") from _call_fight_1
    hide coolwitch
    if _return:
        $ beat += 1

    "Let's get you all healed up for your final match."
    $ wn = witches["witch3"]["name"]
    show cutewitch
    "Finally, you face [wn]"
    call fight("witch3") from _call_fight_2
    hide cutewitch
    if _return:
        $ beat += 1

    "The battle section of the wizard tournament is now over!"
    "The judges must confer."
    "We hand out awards in three...{w=1.0} two...{w=1.0} one..."

    if beat == 0:
        jump lost
    if beat == 1:
        jump beat1
    if beat == 2:
        jump beat2
    if beat == 3:
        jump beat3

# SHOULDN'T NEED TO EDIT BELOW HERE, HOPEFULLY. BELOW IS FIGHT LOGIC

label mini_group(g, sg):
    return True

label mini_poset():
    return True

label mini_push():
    return True

# AnimatedValue(value=0.0, range=1.0, delay=1.0, old_value=None)

# This screen displays a single stat.
screen char_stats(name, hp, maxhp, mana, maxmana, xalign):

    frame:
        padding (10, 10)
        xalign xalign

        vbox:
            spacing 5

            hbox:
                text "[name!t]" min_width 220

            hbox:
                text _("HP "):
                    min_width 40
                    yalign 0.5

                bar:
                    value AnimatedValue(hp, maxhp, 1.0)
                    xmaximum 180
                    ysize 26

                text " [hp]/[maxhp]":
                    yalign 0.5

            hbox:
                text _("Ma "):
                    min_width 40
                    yalign 0.5

                bar:
                    value AnimatedValue(mana, maxmana, 1.0)
                    xmaximum 180
                    ysize 26

                text " [mana]/[maxmana]":
                    yalign 0.5


# This screen uses single_stat to display two stats at once.
screen stats():
    use char_stats(_("Me"), player_hp, max_hp, player_m, player_maxm, 0.0)
    use char_stats(witches[opp]["name"], opp_hp, max_hp, opp_m, opp_maxm, 1.0)
    frame:
        padding (10, 10)
        xalign 0.5
        vbox:
            xmaximum 180
            text "Depth: [depth]"

screen poset_select():
    imagemap:
        xalign 0.5
        yalign 0.5
        idle "poset idle"
        hover "poset hover"
        hotspot (108, 2, 30, 30) action Return(set(["a","b","c"]))
        hotspot (0, 96, 30, 30) action Return(set(["a","b"]))
        hotspot (108, 96, 30, 30) action Return(set(["a","c"]))
        hotspot (216, 96, 30, 30) action Return(set(["b","c"]))
        hotspot (0, 190, 30, 30) action Return(set(["a"]))
        hotspot (108, 190, 30, 30) action Return(set(["b"]))
        hotspot (216, 190, 30, 30) action Return(set(["c"]))


label witchmove:
    # Dragon - Groups
    label .witch1(ph, pm, oh, om, oe, dd):
        $ recharge = {"type": "recharge"}
        $ stick = {"type": "stick"}
        if om < 50:
            if renpy.random.choice([True, False, False]):
                return recharge
        $ op_g = renpy.random.choice([6,8,10])
        if op_g == 6:
            $ op_sg = renpy.random.choice([1, 2, 3, 6])
        if op_g == 8:
            $ op_sg = renpy.random.choice([1, 2, 4, 8])
        if op_g == 10:
            $ op_sg = renpy.random.choice([1, 2, 5, 10])
        if 10*op_sg < om:
            return {"type": "group", "g": op_g, "sg": op_sg}
        else:
            return renpy.random.choice([recharge, recharge, stick])

    # Cool - Posets
    label .witch2(ph, pm, oh, om, oe, dd):
        $ recharge = {"type": "recharge"}
        $ stick = {"type": "stick"}
        $ blast = {"type": "blast"}
        $ point = set(["",
            renpy.random.choice(["", "a"]),
            renpy.random.choice(["", "b"]),
            renpy.random.choice(["", "c"])
            ])
        $ point.remove("")
        $ defend = {"type": "defend", "point": point}
        $ enhance = {"type": "enhance", "point": point}
        if om < 10:
            return recharge
        if om < 50:
            if renpy.random.choice([True, False, False]):
                return recharge
        if len(oe) > 0:
            return renpy.random.choice([stick, blast, blast, blast, blast, blast, blast, blast, defend, enhance])
        else:
            return renpy.random.choice([recharge, blast, defend, enhance])

    # CuteBot - PushPop
    label .witch3(ph, pm, oh, om, oe, dd):
        $ recharge = {"type": "recharge"}
        $ stick = {"type": "stick"}
        $ blast = {"type": "blast"}
        $ push = {"type": "push", "wager": min(5*renpy.random.randint(3,15), oh), "mana": min(renpy.random.choice([10, 20, 30]), om)}
        if om < 10:
            return renpy.random.choice([recharge, stick])
        if om < 45:
            if renpy.random.choice([True, False, False]):
                return recharge
        if dd >= 3:
            return renpy.random.choice([stick, blast, blast, blast])
        elif dd == 0:
            return {"type": "push", "wager": 5*min(renpy.random.randint(3,15), oh), "mana": min(renpy.random.choice([10, 20, 30]), om)}
        elif dd == 2:
            return renpy.random.choice([stick, blast, blast, push])
        elif dd == 1:
            return renpy.random.choice([push, push, blast, blast, stick])
        else:
            return stick

label fight(opponent, hp=100, player_mana=100, opp_mana=100, d=0):
    python:
        renpy.dynamic("opp", "player_hp", "opp_hp", "player_m", "opp_m", "player_enhance", "opp_enhance", "player_enhance_turn", "opp_enhance_turn", "player_sheild", "opp_sheild", "depth", "player_maxm", "opp_maxm", "max_hp", "pushed", "actor", "dmg")
        opp = opponent
        player_hp = hp
        opp_hp = hp
        player_m = player_mana
        opp_m = opp_mana
        player_enhance = set()
        opp_enhance = set()
        player_enhance_turn = 0
        opp_enhance_turn = 0
        player_sheild = set()
        opp_sheild = set()
        depth = d
        player_maxm = player_mana
        opp_maxm = opp_mana
        max_hp = hp
        pushed = False
        actor = ""
        dmg = 0

    # ph, pm, oh, om, pe, dd
    show screen stats

    label .top:
        # hide screen battle_dash
        # show screen battle_dash(player_hp, player_m, opp_hp, opp_m, player_enhance, depth)
        # "this is the top"
        pass

    menu:
        "What do you do?"

        "Basic Actions":
            menu:
                "Recharge":
                    $ player_move = {"type": "recharge"}
                "Use Stick":
                    $ player_move = {"type": "stick"}
                "Magic Blast":
                    $ player_move = {"type": "blast"}

        "Elemental" if books["book1"]["read"]:
            menu:
                "Choose a group"
                "D_6 (Water)":
                    $ g = 6
                "D_8 (Fire)":
                    $ g = 8
                "D_10 (Earth)":
                    $ g = 10
            menu:
                "Choose a subgroup size"
                "1":
                    $ sg = 1
                "2":
                    $ sg = 2
                "3" if g == 6:
                    $ sg = 3
                "4" if g == 8:
                    $ sg = 4
                "5" if g == 10:
                    $ sg = 5
                "6" if g == 6:
                    $ sg = 6
                "8" if g == 8:
                    $ sg = 8
                "10" if g == 10:
                    $ sg = 10
            $ player_move = {"type": "group", "g": g, "sg": sg}
            call mini_group pass (g, sg) from _call_mini_group
            if not _return:
                "Your attack failed."
                $ player_move["failed"] = True

        "Poset" if books["book2"]["read"]:
            menu:
                "Poset Defend":
                    call screen poset_select
                    $ point = _return
                    $ player_move = {"type": "defend", "point": point}

                "Poset Enhance":
                    call screen poset_select
                    $ point = _return
                    $ player_move = {"type": "enhance", "point": point}

        "Push" if books["book3"]["read"]:
            $ hpwager = min(player_hp, int(renpy.input("How much HP do you want to wager?").strip()))
            $ manaboost = int(renpy.input("How much mana do you want to infuse your fantasy-self with?").strip())
            $ player_move = {"type": "push", "wager": hpwager, "mana": manaboost}
            # call fight(opp, hpwager, player_m + manaboost, opp_m, d=depth+1)
            # player_m -= manaboost
            # if _return == True:
            #     opp_hp -= hpwager
            # else:
            #     player_hp -= hpwager

    call expression "witchmove."+opp pass (player_hp, player_m, opp_hp, opp_m, opp_enhance, depth) from _call_expression_7
    $ opp_move = _return

    python:
        priority = {
            "recharge": 6,
            "stick": 6,
            "defend": 4,
            "blast": 2,
            "group": 2,
            "enhance": 0,
            "push": -2
        }
    $ move_order = sorted([{"actor": "player", "move": player_move}, {"actor": "opp", "move": opp_move}], key=lambda x: -priority[x["move"]["type"]])

    # "Moves: [move_order!q]"

    $ witchname = witches[opp]["name"]
    $ bothpush = (player_move["type"] == "push" and opp_move["type"] == "push")
    $ pushed = False

    python:
        for thing in move_order:
            move = thing["move"]
            actor = thing["actor"]
            if move["type"] == "recharge":
                if actor == "player":
                    player_m = min(player_m+10, 100)
                    renpy.say(narrator, "You rested and regained 10 mana.".format())
                else:
                    opp_m = min(opp_m+10, 100)
                    renpy.say(narrator, "{} rested and regained 10 mana.".format(witchname))
            elif move["type"] == "stick":
                crittext = ""
                crit = renpy.random.choice([True, False, False, False, False, False])
                dmg = renpy.random.randint(1, 3)
                if crit:
                    dmg += 7
                    crittext = "It was a critical hit! "
                if actor == "player":
                    opp_hp -= dmg
                    renpy.say(narrator, "You used your stick. {}It did {} damage.".format(crittext, dmg))
                else:
                    player_hp -= dmg
                    renpy.say(narrator, "{} used her stick. {}It did {} damage.".format(witchname, crittext, dmg))
            elif move["type"] == "blast":
                crittext = ""
                crit = renpy.random.choice([renpy.random.choice([True, False, False, False, False, False]), False])
                dmg = renpy.random.randint(5, 7) + renpy.random.randint(0, 1)
                if crit:
                    dmg *= 2
                    crittext = "It was a critical hit! "
                if actor == "player":
                    if player_m >= 5:
                        player_m -= 5
                        if len(opp_sheild) > 0 and player_enhance.issubset(opp_sheild):
                            renpy.say(narrator, "You used Magic Blast, but it was blocked.".format())
                        else:
                            opp_hp -= dmg
                            renpy.say(narrator, "You used Magic Blast. {}It did {} damage.".format(crittext, dmg))
                    else:
                        renpy.say(narrator, "You tried to use Magic Blast, but you don't have enough mana.")
                else:
                    opp_m -= 5
                    if len(player_sheild) > 0 and opp_enhance.issubset(player_sheild):
                        renpy.say(narrator, "{} used Magic Blast, but it was blocked.".format(witchname))
                    else:
                        player_hp -= dmg
                        renpy.say(narrator, "{} used Magic Blast. {}It did {} damage.".format(witchname, crittext, dmg))
            elif move["type"] == "group":
                movename = {
                    6: {1: "Squirt", 2: "Water Shot", 3: "Water Wave", 6: "Hurricane"},
                    8: {1: "Ember", 2: "Flame Shot", 4: "Heat Stroke", 8: "Wildfire"},
                    10: {1: "Sand", 2: " Mudshot", 5: "Ground Shake", 10: "Earthshatter"}
                }[move["g"]][move["sg"]]
                dmg = 10*move["sg"]
                if actor == "player":
                    if player_m >= dmg:
                        player_m -= dmg
                        if len(opp_sheild) > 0 and player_enhance.issubset(opp_sheild):
                            renpy.say(narrator, "You used {}, but it was blocked.".format(movename))
                        else:
                            opp_hp -= dmg
                            renpy.say(narrator, "You used {}. It did {} damage.".format(movename, dmg))
                    else:
                        renpy.say(narrator, "You tried to use {}, but you don't have enough mana.".format(movename))
                else:
                    opp_m -= dmg
                    if len(player_sheild) > 0 and opp_enhance.issubset(player_sheild):
                        renpy.say(narrator, "{} used {}, but it was blocked.".format(witchname, movename))
                    else:
                        player_hp -= dmg
                        renpy.say(narrator, "{} used {}. It did {} damage.".format(witchname, movename, dmg))
            elif move["type"] == "defend":
                if actor == "player":
                    manacost = 10*len(move["point"])
                    if player_m >= manacost:
                        player_m -= manacost
                        player_sheild = move["point"]
                    else:
                        renpy.say(narrator, "You tried to use Poset Defense, but you don't have enough mana.")
                else:
                    opp_m -= 10*len(move["point"])
                    opp_sheild = move["point"]
            elif move["type"] == "enhance":
                if actor == "player":
                    manacost = 10*len(move["point"])
                    if player_m >= manacost:
                        player_m -= manacost
                        player_enhance = move["point"]
                        player_enhance_turn = 0
                    else:
                        renpy.say(narrator, "You tried to use Poset Enhance, but you don't have enough mana.")
                else:
                    opp_m -= 10*len(move["point"])
                    opp_enhance = move["point"]
                    opp_enhance_turn = 0
            elif move["type"] == "push":
                if not bothpush:
                    if actor == "player":
                        if player_m >= move["mana"]:
                            renpy.say(narrator, "You push into a fantasy world...")
                            prev_mana = player_m
                            player_m -= move["mana"]
                            dmg = move["wager"]
                            pushed = True
                            renpy.call("fight", opp, move["wager"], prev_mana + move["mana"], opp_m, d=depth+1)
                        else:
                            renpy.say(narrator, "You tried to Push, but you don't have enough mana.")
                    else:
                        if opp_m >= move["mana"]:
                            renpy.say(narrator, "{} pushed you into a fantasy world...".format(witchname))
                            prev_mana = opp_m
                            opp_m -= move["mana"]
                            dmg = move["wager"]
                            pushed = True
                            renpy.call("fight", opp, move["wager"], player_m, prev_mana + move["mana"], d=depth+1)
                        else:
                            renpy.say(narrator, "{} tried to Push, but she doesn't have enough mana.".format(witchname))

    if pushed:
        python:
            if actor == "player":
                if _return == True:
                    opp_hp -= dmg
                    renpy.say(narrator, "You popped out of a fantasy world. Your wager payed off, doing {} damage to {}.".format(dmg, witchname))
                else:
                    player_hp -= dmg
                    renpy.say(narrator, "You popped out of a fantasy world. Your wager backfired, doing {} damage to you.".format(dmg))
            else:
                if _return == True:
                    opp_hp -= dmg
                    renpy.say(narrator, "You popped out of a fantasy world. You beat {} at her own game, doing {} damage to her.".format(witchname, dmg))
                else:
                    player_hp -= dmg
                    renpy.say(narrator, "You popped out of a fantasy world. {}'s wager cost you {} damage.".format(witchname, dmg))

    if bothpush:
        # TODO
        "You and [witchname] both tried pushing at the same time. Neither one went through."
        # python:
        #     renpy.say(narrator, "You and {} both push into a fantasy world...".format(witchname))
        #     prev_mana = player_m
        #     player_m -= move["mana"]
        #     dmg = move["wager"]
        #     pushed = True
        #     renpy.call("fight", opp, move["wager"], prev_mana + move["mana"], opp_m, d=depth+1)

    python:
        player_sheild = set()
        opp_sheild = set()
        player_enhance_turn += 1
        opp_enhance_turn += 1
        if player_enhance_turn >= 2:
            player_enhance = set([])
        if opp_enhance_turn >= 2:
            opp_enhance = set([])

    if opp_hp <= 0:
        if depth == 0:
            "You win!"
            hide screen stats
        return True
    if player_hp <= 0:
        if depth == 0:
            hide screen stats
            "You lose!"
        return False

    jump .top
