define w = Character("Wizard", color="#FFD700")

label wizardintro:

    scene bkg blackscreen

    "Huh? What happened? Where am I?"

    "Wait a second... Who am I?"

    python:
        pname = renpy.input(_("Type your name"))

        pname = pname.strip() or __("Apprentice")

    define a = Character("[pname]", color="#ffffff")

    play music "audio/halfmystery.mp3" fadeout 1

    scene bkg wizardroom
    with Dissolve(.5)

    pause .5

    show wizard
    with Dissolve(.5)

    w "Ah!"

    # w "Oh, it's just you, [pname]."

    # w "You know better than to sneak up on a wizard like that. Anywho, I thought I left you "

    w "Thank Gödel, you're awake!"

    w "I mean, I knew you'd wake up, [pname]... eventually, anyhow. Anti-paradox potion always works. At least, it has always worked so far. "

    w "Let's celebrate."

    a "Celebrate? I could've died!"

    w "Knowing time, you still can, haha."

    a "Wizard! This isn't funny!"

    w "You're right. You're right. Sorry."

    w "Let's protect against death with some protection spells."

    w "Do you remember how to use the Menu spell? You can either press your escape key or right click to activate it."

    w "Sorry, again, [pname]. Sometimes I forget how hard anti-paradox potion affects memory. One of the symptoms was amnesia, I think."

    w "We just spent the last year learning time spells."

    menu:

        w "Would you like a quick refresh on how to use your Menu spell?"

        "Yes.":
            w "Alrighty, then!"
            w "After you activate your Menu spell, you should see a few options."
            w "You can use your Save spell in order to bookmark this moment in time."
            w "You can use Load to go back in time to any of your saved moments."
            w "You can use History to re-read text and see what timeline everyone else thinks you're in."
            w "In Preferences, you can change your perception of reality."
            w "Display can make your viewing screen bigger or smaller."
            w "Rollback side is a quick time spell. If you enable it, then you can choose to go back in time by clicking the left or right side of the screen. Whichever side you choose to enable."
            w "If you want to go back in time without using your Menu spell, you can click Back at the bottom of the screen."
            w "I'm getting off track. Back to Preferences!"
            w "Skip will move you forward in time by skiping any text that you have already seen before. "
            w "You can use Text speed to control how fast or slow others talk."
            w "Auto forward time is a little complicated. If the slider is all the way to the right, then time moves forward automatically. If the slider is all the way to the left, then time only moves forward when you tell it to move through clicking. "
            w "Volume controls how loud or quiet you want the music to be."
            w "You can also access the History, Save, and Preference options of your Menu spell from the bottom of the screen."
            w "Remember that by pressing Back, you can go back in time by one screen. It took you a few months to figure that one out."

        "No.":
            w "Yay! You remembered!"

    w "I'm so proud of your progress. You're picking all of this up much faster than any of my other apprentices."
    w "But perhaps that's just because you utilize your Save and Load spells more often and go back in time to practice more."
    w "Whatever the case, I'm very proud of you, [pname]."

    a "Aaaaaaaaand?"

    w "And what? Can a wizard not praise their apprentice every now and then without getting criticized?"

    menu:

        "You're up to something.":
            a "A wizard can. You rarely do. Your praise is almost always followed by some sort of dangerous quest. Can you really blame me for being skeptical?"

        "You're right, I'm sorry.":
            a "You're right. Go ahead. Praise me."

    w "You're so very intuitive and smart and capable."

    a "Thank you."

    w "And that's why I signed you up for the wizard tournament."

    a "You did what?!?!?!"

    w "I signed you up for the wizard tournament. It's later today."

    a "Why would you do that?"

    w "[pname], I've known you for a while. You picked up the Menu spell super fast. I think it's time for you to spread your metaphorical wings and fly."
    w "Today's tournament is the perfect opportunity for you to test your magical skills. Also, I kinda sorta bragged about you to the other wizards. So, you can't let me down!"

    menu:
        w "You're excited for the wizard tournament, right?"

        "Yes!":
            w "Great!"

        "No.":
            w "Stop lying. I know you're secretly excited. Everyone loves magic battles."

    w "While you were sleeping, all of the other witches and wizards arrived for the tournament. They're waiting in the courtyard, outside."

    w "Maybe you should learn a few of their secrets before the tournament. Knowing a few extra spells could't hurt."

    a "Got it."

    w "Oh! One last thing before you go! Their wizard mentors all hate each other."

    a "Okay... This matters how?"

    w "You'll only be able to befriend one of them at a time. So, go back in time if you need to... or want to. Alright! I've got a show to catch! Have fun!"

    jump hallway


label peptalk:
    play music "audio/halfmystery.mp3" fadeout 1
    scene bkg wizardroom
    show wizard
    with flashbulb


    w "Hold it right there, [pname]!"
    w "You can't go to the wizard tournament without hearing my words of encouragement!"
    w "I wrote a speech and everything!"
    a "Alright. Give your speech. Then I'm going."
    w "You won't regret this!"
    a "I sure hope not."
    w "First off!"
    show wizard
    with flashbulb
    w "I'm giving you your very own wand. Exciting, I know."
    w "You can use your wand to cast a magic blast attack. You can also use it to recharge mana."
    w "If both of those fail you, you can run over to your opponent and hit them with it."
    a "That can't be legal."
    w "Oh, hush, now. Of course it's legal!"
    w "Would I ever send you down the wrong path?"
    a "You sent me into ancient history last week... and I almost didn't wake up. Remember this morning?"
    w "This morning?"
    w "Yes, this morning! When I told you about the wizard tournament!"
    w "As you know, no student of mine has ever lost a wizard tournament. Coincidentally, time travel magic is forbidden during the tournament..."
    w "But it's not banned after and before, if you catch my rift. ;)"
    w "Ah? You aren't laughing. TIME RIFT! I'm telling you to cheat. We're going to cheat. We'll go back in time until you win."
    #have wizard tell player to disable rollback side in case they accidentally use time travel. using time travel will make them lose.
    a "Was this your idea of a peptalk?"
    w "Yes. I don't see a problem with it."
    a "You're telling me to cheat."
    w "[pname], [pname], [pname]... Cheating is just another word for opportunity."
    a "No, it isn't."
    w "Really? Hold on. Let me check the dictionary."
    show wizard
    with flashbulb
    w "Wow. You're right. Sorry about that. Note to self, go back in time and change the definition of the word cheating to avoid this awkward moment."
    a "So, can I go to the wizard tournament, now?"
    w "Only if my peptalk inspired you."
    menu:
        w "Did my peptalk inspire you?"

        "Yes.":
            pass
        "Yes.":
            pass
    w "Great! I am such a great mentor. I should really take more breaks and reward myself more often."
    w "Have fun at the tournament! Don't let the other wizards think I'm a bad teacher! Beat their students by a large margin! Show some team pride!"

    menu:
        "Alright, are you ready for the tournament?"

        "Let's go!":
            "Good luck!"
            jump tourney

        "Nah, I'll ditch":
            "Wow, what a jerk you are. You'll regret this."
            jump noshow
